// generated from rosidl_typesupport_fastrtps_cpp/resource/idl__type_support.cpp.em
// with input from novatel_gps_msgs:msg/NovatelMessageHeader.idl
// generated code does not contain a copyright notice
#include "novatel_gps_msgs/msg/detail/novatel_message_header__rosidl_typesupport_fastrtps_cpp.hpp"
#include "novatel_gps_msgs/msg/detail/novatel_message_header__struct.hpp"

#include <limits>
#include <stdexcept>
#include <string>
#include "rosidl_typesupport_cpp/message_type_support.hpp"
#include "rosidl_typesupport_fastrtps_cpp/identifier.hpp"
#include "rosidl_typesupport_fastrtps_cpp/message_type_support.h"
#include "rosidl_typesupport_fastrtps_cpp/message_type_support_decl.hpp"
#include "rosidl_typesupport_fastrtps_cpp/wstring_conversion.hpp"
#include "fastcdr/Cdr.h"


// forward declaration of message dependencies and their conversion functions
namespace novatel_gps_msgs
{
namespace msg
{
namespace typesupport_fastrtps_cpp
{
bool cdr_serialize(
  const novatel_gps_msgs::msg::NovatelReceiverStatus &,
  eprosima::fastcdr::Cdr &);
bool cdr_deserialize(
  eprosima::fastcdr::Cdr &,
  novatel_gps_msgs::msg::NovatelReceiverStatus &);
size_t get_serialized_size(
  const novatel_gps_msgs::msg::NovatelReceiverStatus &,
  size_t current_alignment);
size_t
max_serialized_size_NovatelReceiverStatus(
  bool & full_bounded,
  bool & is_plain,
  size_t current_alignment);
}  // namespace typesupport_fastrtps_cpp
}  // namespace msg
}  // namespace novatel_gps_msgs


namespace novatel_gps_msgs
{

namespace msg
{

namespace typesupport_fastrtps_cpp
{

bool
ROSIDL_TYPESUPPORT_FASTRTPS_CPP_PUBLIC_novatel_gps_msgs
cdr_serialize(
  const novatel_gps_msgs::msg::NovatelMessageHeader & ros_message,
  eprosima::fastcdr::Cdr & cdr)
{
  // Member: message_name
  cdr << ros_message.message_name;
  // Member: port
  cdr << ros_message.port;
  // Member: sequence_num
  cdr << ros_message.sequence_num;
  // Member: percent_idle_time
  cdr << ros_message.percent_idle_time;
  // Member: gps_time_status
  cdr << ros_message.gps_time_status;
  // Member: gps_week_num
  cdr << ros_message.gps_week_num;
  // Member: gps_seconds
  cdr << ros_message.gps_seconds;
  // Member: receiver_status
  novatel_gps_msgs::msg::typesupport_fastrtps_cpp::cdr_serialize(
    ros_message.receiver_status,
    cdr);
  // Member: receiver_software_version
  cdr << ros_message.receiver_software_version;
  return true;
}

bool
ROSIDL_TYPESUPPORT_FASTRTPS_CPP_PUBLIC_novatel_gps_msgs
cdr_deserialize(
  eprosima::fastcdr::Cdr & cdr,
  novatel_gps_msgs::msg::NovatelMessageHeader & ros_message)
{
  // Member: message_name
  cdr >> ros_message.message_name;

  // Member: port
  cdr >> ros_message.port;

  // Member: sequence_num
  cdr >> ros_message.sequence_num;

  // Member: percent_idle_time
  cdr >> ros_message.percent_idle_time;

  // Member: gps_time_status
  cdr >> ros_message.gps_time_status;

  // Member: gps_week_num
  cdr >> ros_message.gps_week_num;

  // Member: gps_seconds
  cdr >> ros_message.gps_seconds;

  // Member: receiver_status
  novatel_gps_msgs::msg::typesupport_fastrtps_cpp::cdr_deserialize(
    cdr, ros_message.receiver_status);

  // Member: receiver_software_version
  cdr >> ros_message.receiver_software_version;

  return true;
}

size_t
ROSIDL_TYPESUPPORT_FASTRTPS_CPP_PUBLIC_novatel_gps_msgs
get_serialized_size(
  const novatel_gps_msgs::msg::NovatelMessageHeader & ros_message,
  size_t current_alignment)
{
  size_t initial_alignment = current_alignment;

  const size_t padding = 4;
  const size_t wchar_size = 4;
  (void)padding;
  (void)wchar_size;

  // Member: message_name
  current_alignment += padding +
    eprosima::fastcdr::Cdr::alignment(current_alignment, padding) +
    (ros_message.message_name.size() + 1);
  // Member: port
  current_alignment += padding +
    eprosima::fastcdr::Cdr::alignment(current_alignment, padding) +
    (ros_message.port.size() + 1);
  // Member: sequence_num
  {
    size_t item_size = sizeof(ros_message.sequence_num);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // Member: percent_idle_time
  {
    size_t item_size = sizeof(ros_message.percent_idle_time);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // Member: gps_time_status
  current_alignment += padding +
    eprosima::fastcdr::Cdr::alignment(current_alignment, padding) +
    (ros_message.gps_time_status.size() + 1);
  // Member: gps_week_num
  {
    size_t item_size = sizeof(ros_message.gps_week_num);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // Member: gps_seconds
  {
    size_t item_size = sizeof(ros_message.gps_seconds);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // Member: receiver_status

  current_alignment +=
    novatel_gps_msgs::msg::typesupport_fastrtps_cpp::get_serialized_size(
    ros_message.receiver_status, current_alignment);
  // Member: receiver_software_version
  {
    size_t item_size = sizeof(ros_message.receiver_software_version);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }

  return current_alignment - initial_alignment;
}

size_t
ROSIDL_TYPESUPPORT_FASTRTPS_CPP_PUBLIC_novatel_gps_msgs
max_serialized_size_NovatelMessageHeader(
  bool & full_bounded,
  bool & is_plain,
  size_t current_alignment)
{
  size_t initial_alignment = current_alignment;

  const size_t padding = 4;
  const size_t wchar_size = 4;
  size_t last_member_size = 0;
  (void)last_member_size;
  (void)padding;
  (void)wchar_size;

  full_bounded = true;
  is_plain = true;


  // Member: message_name
  {
    size_t array_size = 1;

    full_bounded = false;
    is_plain = false;
    for (size_t index = 0; index < array_size; ++index) {
      current_alignment += padding +
        eprosima::fastcdr::Cdr::alignment(current_alignment, padding) +
        1;
    }
  }

  // Member: port
  {
    size_t array_size = 1;

    full_bounded = false;
    is_plain = false;
    for (size_t index = 0; index < array_size; ++index) {
      current_alignment += padding +
        eprosima::fastcdr::Cdr::alignment(current_alignment, padding) +
        1;
    }
  }

  // Member: sequence_num
  {
    size_t array_size = 1;

    last_member_size = array_size * sizeof(uint32_t);
    current_alignment += array_size * sizeof(uint32_t) +
      eprosima::fastcdr::Cdr::alignment(current_alignment, sizeof(uint32_t));
  }

  // Member: percent_idle_time
  {
    size_t array_size = 1;

    last_member_size = array_size * sizeof(uint32_t);
    current_alignment += array_size * sizeof(uint32_t) +
      eprosima::fastcdr::Cdr::alignment(current_alignment, sizeof(uint32_t));
  }

  // Member: gps_time_status
  {
    size_t array_size = 1;

    full_bounded = false;
    is_plain = false;
    for (size_t index = 0; index < array_size; ++index) {
      current_alignment += padding +
        eprosima::fastcdr::Cdr::alignment(current_alignment, padding) +
        1;
    }
  }

  // Member: gps_week_num
  {
    size_t array_size = 1;

    last_member_size = array_size * sizeof(uint32_t);
    current_alignment += array_size * sizeof(uint32_t) +
      eprosima::fastcdr::Cdr::alignment(current_alignment, sizeof(uint32_t));
  }

  // Member: gps_seconds
  {
    size_t array_size = 1;

    last_member_size = array_size * sizeof(uint64_t);
    current_alignment += array_size * sizeof(uint64_t) +
      eprosima::fastcdr::Cdr::alignment(current_alignment, sizeof(uint64_t));
  }

  // Member: receiver_status
  {
    size_t array_size = 1;


    last_member_size = 0;
    for (size_t index = 0; index < array_size; ++index) {
      bool inner_full_bounded;
      bool inner_is_plain;
      size_t inner_size =
        novatel_gps_msgs::msg::typesupport_fastrtps_cpp::max_serialized_size_NovatelReceiverStatus(
        inner_full_bounded, inner_is_plain, current_alignment);
      last_member_size += inner_size;
      current_alignment += inner_size;
      full_bounded &= inner_full_bounded;
      is_plain &= inner_is_plain;
    }
  }

  // Member: receiver_software_version
  {
    size_t array_size = 1;

    last_member_size = array_size * sizeof(uint32_t);
    current_alignment += array_size * sizeof(uint32_t) +
      eprosima::fastcdr::Cdr::alignment(current_alignment, sizeof(uint32_t));
  }

  size_t ret_val = current_alignment - initial_alignment;
  if (is_plain) {
    // All members are plain, and type is not empty.
    // We still need to check that the in-memory alignment
    // is the same as the CDR mandated alignment.
    using DataType = novatel_gps_msgs::msg::NovatelMessageHeader;
    is_plain =
      (
      offsetof(DataType, receiver_software_version) +
      last_member_size
      ) == ret_val;
  }

  return ret_val;
}

static bool _NovatelMessageHeader__cdr_serialize(
  const void * untyped_ros_message,
  eprosima::fastcdr::Cdr & cdr)
{
  auto typed_message =
    static_cast<const novatel_gps_msgs::msg::NovatelMessageHeader *>(
    untyped_ros_message);
  return cdr_serialize(*typed_message, cdr);
}

static bool _NovatelMessageHeader__cdr_deserialize(
  eprosima::fastcdr::Cdr & cdr,
  void * untyped_ros_message)
{
  auto typed_message =
    static_cast<novatel_gps_msgs::msg::NovatelMessageHeader *>(
    untyped_ros_message);
  return cdr_deserialize(cdr, *typed_message);
}

static uint32_t _NovatelMessageHeader__get_serialized_size(
  const void * untyped_ros_message)
{
  auto typed_message =
    static_cast<const novatel_gps_msgs::msg::NovatelMessageHeader *>(
    untyped_ros_message);
  return static_cast<uint32_t>(get_serialized_size(*typed_message, 0));
}

static size_t _NovatelMessageHeader__max_serialized_size(char & bounds_info)
{
  bool full_bounded;
  bool is_plain;
  size_t ret_val;

  ret_val = max_serialized_size_NovatelMessageHeader(full_bounded, is_plain, 0);

  bounds_info =
    is_plain ? ROSIDL_TYPESUPPORT_FASTRTPS_PLAIN_TYPE :
    full_bounded ? ROSIDL_TYPESUPPORT_FASTRTPS_BOUNDED_TYPE : ROSIDL_TYPESUPPORT_FASTRTPS_UNBOUNDED_TYPE;
  return ret_val;
}

static message_type_support_callbacks_t _NovatelMessageHeader__callbacks = {
  "novatel_gps_msgs::msg",
  "NovatelMessageHeader",
  _NovatelMessageHeader__cdr_serialize,
  _NovatelMessageHeader__cdr_deserialize,
  _NovatelMessageHeader__get_serialized_size,
  _NovatelMessageHeader__max_serialized_size
};

static rosidl_message_type_support_t _NovatelMessageHeader__handle = {
  rosidl_typesupport_fastrtps_cpp::typesupport_identifier,
  &_NovatelMessageHeader__callbacks,
  get_message_typesupport_handle_function,
};

}  // namespace typesupport_fastrtps_cpp

}  // namespace msg

}  // namespace novatel_gps_msgs

namespace rosidl_typesupport_fastrtps_cpp
{

template<>
ROSIDL_TYPESUPPORT_FASTRTPS_CPP_EXPORT_novatel_gps_msgs
const rosidl_message_type_support_t *
get_message_type_support_handle<novatel_gps_msgs::msg::NovatelMessageHeader>()
{
  return &novatel_gps_msgs::msg::typesupport_fastrtps_cpp::_NovatelMessageHeader__handle;
}

}  // namespace rosidl_typesupport_fastrtps_cpp

#ifdef __cplusplus
extern "C"
{
#endif

const rosidl_message_type_support_t *
ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(rosidl_typesupport_fastrtps_cpp, novatel_gps_msgs, msg, NovatelMessageHeader)() {
  return &novatel_gps_msgs::msg::typesupport_fastrtps_cpp::_NovatelMessageHeader__handle;
}

#ifdef __cplusplus
}
#endif
