// generated from rosidl_typesupport_fastrtps_cpp/resource/idl__type_support.cpp.em
// with input from novatel_gps_msgs:msg/NovatelReceiverStatus.idl
// generated code does not contain a copyright notice
#include "novatel_gps_msgs/msg/detail/novatel_receiver_status__rosidl_typesupport_fastrtps_cpp.hpp"
#include "novatel_gps_msgs/msg/detail/novatel_receiver_status__struct.hpp"

#include <limits>
#include <stdexcept>
#include <string>
#include "rosidl_typesupport_cpp/message_type_support.hpp"
#include "rosidl_typesupport_fastrtps_cpp/identifier.hpp"
#include "rosidl_typesupport_fastrtps_cpp/message_type_support.h"
#include "rosidl_typesupport_fastrtps_cpp/message_type_support_decl.hpp"
#include "rosidl_typesupport_fastrtps_cpp/wstring_conversion.hpp"
#include "fastcdr/Cdr.h"


// forward declaration of message dependencies and their conversion functions

namespace novatel_gps_msgs
{

namespace msg
{

namespace typesupport_fastrtps_cpp
{

bool
ROSIDL_TYPESUPPORT_FASTRTPS_CPP_PUBLIC_novatel_gps_msgs
cdr_serialize(
  const novatel_gps_msgs::msg::NovatelReceiverStatus & ros_message,
  eprosima::fastcdr::Cdr & cdr)
{
  // Member: original_status_code
  cdr << ros_message.original_status_code;
  // Member: error_flag
  cdr << (ros_message.error_flag ? true : false);
  // Member: temperature_flag
  cdr << (ros_message.temperature_flag ? true : false);
  // Member: voltage_supply_flag
  cdr << (ros_message.voltage_supply_flag ? true : false);
  // Member: antenna_powered
  cdr << (ros_message.antenna_powered ? true : false);
  // Member: antenna_is_open
  cdr << (ros_message.antenna_is_open ? true : false);
  // Member: antenna_is_shorted
  cdr << (ros_message.antenna_is_shorted ? true : false);
  // Member: cpu_overload_flag
  cdr << (ros_message.cpu_overload_flag ? true : false);
  // Member: com1_buffer_overrun
  cdr << (ros_message.com1_buffer_overrun ? true : false);
  // Member: com2_buffer_overrun
  cdr << (ros_message.com2_buffer_overrun ? true : false);
  // Member: com3_buffer_overrun
  cdr << (ros_message.com3_buffer_overrun ? true : false);
  // Member: usb_buffer_overrun
  cdr << (ros_message.usb_buffer_overrun ? true : false);
  // Member: rf1_agc_flag
  cdr << (ros_message.rf1_agc_flag ? true : false);
  // Member: rf2_agc_flag
  cdr << (ros_message.rf2_agc_flag ? true : false);
  // Member: almanac_flag
  cdr << (ros_message.almanac_flag ? true : false);
  // Member: position_solution_flag
  cdr << (ros_message.position_solution_flag ? true : false);
  // Member: position_fixed_flag
  cdr << (ros_message.position_fixed_flag ? true : false);
  // Member: clock_steering_status_enabled
  cdr << (ros_message.clock_steering_status_enabled ? true : false);
  // Member: clock_model_flag
  cdr << (ros_message.clock_model_flag ? true : false);
  // Member: oemv_external_oscillator_flag
  cdr << (ros_message.oemv_external_oscillator_flag ? true : false);
  // Member: software_resource_flag
  cdr << (ros_message.software_resource_flag ? true : false);
  // Member: aux1_status_event_flag
  cdr << (ros_message.aux1_status_event_flag ? true : false);
  // Member: aux2_status_event_flag
  cdr << (ros_message.aux2_status_event_flag ? true : false);
  // Member: aux3_status_event_flag
  cdr << (ros_message.aux3_status_event_flag ? true : false);
  return true;
}

bool
ROSIDL_TYPESUPPORT_FASTRTPS_CPP_PUBLIC_novatel_gps_msgs
cdr_deserialize(
  eprosima::fastcdr::Cdr & cdr,
  novatel_gps_msgs::msg::NovatelReceiverStatus & ros_message)
{
  // Member: original_status_code
  cdr >> ros_message.original_status_code;

  // Member: error_flag
  {
    uint8_t tmp;
    cdr >> tmp;
    ros_message.error_flag = tmp ? true : false;
  }

  // Member: temperature_flag
  {
    uint8_t tmp;
    cdr >> tmp;
    ros_message.temperature_flag = tmp ? true : false;
  }

  // Member: voltage_supply_flag
  {
    uint8_t tmp;
    cdr >> tmp;
    ros_message.voltage_supply_flag = tmp ? true : false;
  }

  // Member: antenna_powered
  {
    uint8_t tmp;
    cdr >> tmp;
    ros_message.antenna_powered = tmp ? true : false;
  }

  // Member: antenna_is_open
  {
    uint8_t tmp;
    cdr >> tmp;
    ros_message.antenna_is_open = tmp ? true : false;
  }

  // Member: antenna_is_shorted
  {
    uint8_t tmp;
    cdr >> tmp;
    ros_message.antenna_is_shorted = tmp ? true : false;
  }

  // Member: cpu_overload_flag
  {
    uint8_t tmp;
    cdr >> tmp;
    ros_message.cpu_overload_flag = tmp ? true : false;
  }

  // Member: com1_buffer_overrun
  {
    uint8_t tmp;
    cdr >> tmp;
    ros_message.com1_buffer_overrun = tmp ? true : false;
  }

  // Member: com2_buffer_overrun
  {
    uint8_t tmp;
    cdr >> tmp;
    ros_message.com2_buffer_overrun = tmp ? true : false;
  }

  // Member: com3_buffer_overrun
  {
    uint8_t tmp;
    cdr >> tmp;
    ros_message.com3_buffer_overrun = tmp ? true : false;
  }

  // Member: usb_buffer_overrun
  {
    uint8_t tmp;
    cdr >> tmp;
    ros_message.usb_buffer_overrun = tmp ? true : false;
  }

  // Member: rf1_agc_flag
  {
    uint8_t tmp;
    cdr >> tmp;
    ros_message.rf1_agc_flag = tmp ? true : false;
  }

  // Member: rf2_agc_flag
  {
    uint8_t tmp;
    cdr >> tmp;
    ros_message.rf2_agc_flag = tmp ? true : false;
  }

  // Member: almanac_flag
  {
    uint8_t tmp;
    cdr >> tmp;
    ros_message.almanac_flag = tmp ? true : false;
  }

  // Member: position_solution_flag
  {
    uint8_t tmp;
    cdr >> tmp;
    ros_message.position_solution_flag = tmp ? true : false;
  }

  // Member: position_fixed_flag
  {
    uint8_t tmp;
    cdr >> tmp;
    ros_message.position_fixed_flag = tmp ? true : false;
  }

  // Member: clock_steering_status_enabled
  {
    uint8_t tmp;
    cdr >> tmp;
    ros_message.clock_steering_status_enabled = tmp ? true : false;
  }

  // Member: clock_model_flag
  {
    uint8_t tmp;
    cdr >> tmp;
    ros_message.clock_model_flag = tmp ? true : false;
  }

  // Member: oemv_external_oscillator_flag
  {
    uint8_t tmp;
    cdr >> tmp;
    ros_message.oemv_external_oscillator_flag = tmp ? true : false;
  }

  // Member: software_resource_flag
  {
    uint8_t tmp;
    cdr >> tmp;
    ros_message.software_resource_flag = tmp ? true : false;
  }

  // Member: aux1_status_event_flag
  {
    uint8_t tmp;
    cdr >> tmp;
    ros_message.aux1_status_event_flag = tmp ? true : false;
  }

  // Member: aux2_status_event_flag
  {
    uint8_t tmp;
    cdr >> tmp;
    ros_message.aux2_status_event_flag = tmp ? true : false;
  }

  // Member: aux3_status_event_flag
  {
    uint8_t tmp;
    cdr >> tmp;
    ros_message.aux3_status_event_flag = tmp ? true : false;
  }

  return true;
}

size_t
ROSIDL_TYPESUPPORT_FASTRTPS_CPP_PUBLIC_novatel_gps_msgs
get_serialized_size(
  const novatel_gps_msgs::msg::NovatelReceiverStatus & ros_message,
  size_t current_alignment)
{
  size_t initial_alignment = current_alignment;

  const size_t padding = 4;
  const size_t wchar_size = 4;
  (void)padding;
  (void)wchar_size;

  // Member: original_status_code
  {
    size_t item_size = sizeof(ros_message.original_status_code);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // Member: error_flag
  {
    size_t item_size = sizeof(ros_message.error_flag);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // Member: temperature_flag
  {
    size_t item_size = sizeof(ros_message.temperature_flag);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // Member: voltage_supply_flag
  {
    size_t item_size = sizeof(ros_message.voltage_supply_flag);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // Member: antenna_powered
  {
    size_t item_size = sizeof(ros_message.antenna_powered);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // Member: antenna_is_open
  {
    size_t item_size = sizeof(ros_message.antenna_is_open);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // Member: antenna_is_shorted
  {
    size_t item_size = sizeof(ros_message.antenna_is_shorted);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // Member: cpu_overload_flag
  {
    size_t item_size = sizeof(ros_message.cpu_overload_flag);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // Member: com1_buffer_overrun
  {
    size_t item_size = sizeof(ros_message.com1_buffer_overrun);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // Member: com2_buffer_overrun
  {
    size_t item_size = sizeof(ros_message.com2_buffer_overrun);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // Member: com3_buffer_overrun
  {
    size_t item_size = sizeof(ros_message.com3_buffer_overrun);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // Member: usb_buffer_overrun
  {
    size_t item_size = sizeof(ros_message.usb_buffer_overrun);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // Member: rf1_agc_flag
  {
    size_t item_size = sizeof(ros_message.rf1_agc_flag);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // Member: rf2_agc_flag
  {
    size_t item_size = sizeof(ros_message.rf2_agc_flag);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // Member: almanac_flag
  {
    size_t item_size = sizeof(ros_message.almanac_flag);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // Member: position_solution_flag
  {
    size_t item_size = sizeof(ros_message.position_solution_flag);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // Member: position_fixed_flag
  {
    size_t item_size = sizeof(ros_message.position_fixed_flag);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // Member: clock_steering_status_enabled
  {
    size_t item_size = sizeof(ros_message.clock_steering_status_enabled);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // Member: clock_model_flag
  {
    size_t item_size = sizeof(ros_message.clock_model_flag);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // Member: oemv_external_oscillator_flag
  {
    size_t item_size = sizeof(ros_message.oemv_external_oscillator_flag);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // Member: software_resource_flag
  {
    size_t item_size = sizeof(ros_message.software_resource_flag);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // Member: aux1_status_event_flag
  {
    size_t item_size = sizeof(ros_message.aux1_status_event_flag);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // Member: aux2_status_event_flag
  {
    size_t item_size = sizeof(ros_message.aux2_status_event_flag);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // Member: aux3_status_event_flag
  {
    size_t item_size = sizeof(ros_message.aux3_status_event_flag);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }

  return current_alignment - initial_alignment;
}

size_t
ROSIDL_TYPESUPPORT_FASTRTPS_CPP_PUBLIC_novatel_gps_msgs
max_serialized_size_NovatelReceiverStatus(
  bool & full_bounded,
  bool & is_plain,
  size_t current_alignment)
{
  size_t initial_alignment = current_alignment;

  const size_t padding = 4;
  const size_t wchar_size = 4;
  size_t last_member_size = 0;
  (void)last_member_size;
  (void)padding;
  (void)wchar_size;

  full_bounded = true;
  is_plain = true;


  // Member: original_status_code
  {
    size_t array_size = 1;

    last_member_size = array_size * sizeof(uint32_t);
    current_alignment += array_size * sizeof(uint32_t) +
      eprosima::fastcdr::Cdr::alignment(current_alignment, sizeof(uint32_t));
  }

  // Member: error_flag
  {
    size_t array_size = 1;

    last_member_size = array_size * sizeof(uint8_t);
    current_alignment += array_size * sizeof(uint8_t);
  }

  // Member: temperature_flag
  {
    size_t array_size = 1;

    last_member_size = array_size * sizeof(uint8_t);
    current_alignment += array_size * sizeof(uint8_t);
  }

  // Member: voltage_supply_flag
  {
    size_t array_size = 1;

    last_member_size = array_size * sizeof(uint8_t);
    current_alignment += array_size * sizeof(uint8_t);
  }

  // Member: antenna_powered
  {
    size_t array_size = 1;

    last_member_size = array_size * sizeof(uint8_t);
    current_alignment += array_size * sizeof(uint8_t);
  }

  // Member: antenna_is_open
  {
    size_t array_size = 1;

    last_member_size = array_size * sizeof(uint8_t);
    current_alignment += array_size * sizeof(uint8_t);
  }

  // Member: antenna_is_shorted
  {
    size_t array_size = 1;

    last_member_size = array_size * sizeof(uint8_t);
    current_alignment += array_size * sizeof(uint8_t);
  }

  // Member: cpu_overload_flag
  {
    size_t array_size = 1;

    last_member_size = array_size * sizeof(uint8_t);
    current_alignment += array_size * sizeof(uint8_t);
  }

  // Member: com1_buffer_overrun
  {
    size_t array_size = 1;

    last_member_size = array_size * sizeof(uint8_t);
    current_alignment += array_size * sizeof(uint8_t);
  }

  // Member: com2_buffer_overrun
  {
    size_t array_size = 1;

    last_member_size = array_size * sizeof(uint8_t);
    current_alignment += array_size * sizeof(uint8_t);
  }

  // Member: com3_buffer_overrun
  {
    size_t array_size = 1;

    last_member_size = array_size * sizeof(uint8_t);
    current_alignment += array_size * sizeof(uint8_t);
  }

  // Member: usb_buffer_overrun
  {
    size_t array_size = 1;

    last_member_size = array_size * sizeof(uint8_t);
    current_alignment += array_size * sizeof(uint8_t);
  }

  // Member: rf1_agc_flag
  {
    size_t array_size = 1;

    last_member_size = array_size * sizeof(uint8_t);
    current_alignment += array_size * sizeof(uint8_t);
  }

  // Member: rf2_agc_flag
  {
    size_t array_size = 1;

    last_member_size = array_size * sizeof(uint8_t);
    current_alignment += array_size * sizeof(uint8_t);
  }

  // Member: almanac_flag
  {
    size_t array_size = 1;

    last_member_size = array_size * sizeof(uint8_t);
    current_alignment += array_size * sizeof(uint8_t);
  }

  // Member: position_solution_flag
  {
    size_t array_size = 1;

    last_member_size = array_size * sizeof(uint8_t);
    current_alignment += array_size * sizeof(uint8_t);
  }

  // Member: position_fixed_flag
  {
    size_t array_size = 1;

    last_member_size = array_size * sizeof(uint8_t);
    current_alignment += array_size * sizeof(uint8_t);
  }

  // Member: clock_steering_status_enabled
  {
    size_t array_size = 1;

    last_member_size = array_size * sizeof(uint8_t);
    current_alignment += array_size * sizeof(uint8_t);
  }

  // Member: clock_model_flag
  {
    size_t array_size = 1;

    last_member_size = array_size * sizeof(uint8_t);
    current_alignment += array_size * sizeof(uint8_t);
  }

  // Member: oemv_external_oscillator_flag
  {
    size_t array_size = 1;

    last_member_size = array_size * sizeof(uint8_t);
    current_alignment += array_size * sizeof(uint8_t);
  }

  // Member: software_resource_flag
  {
    size_t array_size = 1;

    last_member_size = array_size * sizeof(uint8_t);
    current_alignment += array_size * sizeof(uint8_t);
  }

  // Member: aux1_status_event_flag
  {
    size_t array_size = 1;

    last_member_size = array_size * sizeof(uint8_t);
    current_alignment += array_size * sizeof(uint8_t);
  }

  // Member: aux2_status_event_flag
  {
    size_t array_size = 1;

    last_member_size = array_size * sizeof(uint8_t);
    current_alignment += array_size * sizeof(uint8_t);
  }

  // Member: aux3_status_event_flag
  {
    size_t array_size = 1;

    last_member_size = array_size * sizeof(uint8_t);
    current_alignment += array_size * sizeof(uint8_t);
  }

  size_t ret_val = current_alignment - initial_alignment;
  if (is_plain) {
    // All members are plain, and type is not empty.
    // We still need to check that the in-memory alignment
    // is the same as the CDR mandated alignment.
    using DataType = novatel_gps_msgs::msg::NovatelReceiverStatus;
    is_plain =
      (
      offsetof(DataType, aux3_status_event_flag) +
      last_member_size
      ) == ret_val;
  }

  return ret_val;
}

static bool _NovatelReceiverStatus__cdr_serialize(
  const void * untyped_ros_message,
  eprosima::fastcdr::Cdr & cdr)
{
  auto typed_message =
    static_cast<const novatel_gps_msgs::msg::NovatelReceiverStatus *>(
    untyped_ros_message);
  return cdr_serialize(*typed_message, cdr);
}

static bool _NovatelReceiverStatus__cdr_deserialize(
  eprosima::fastcdr::Cdr & cdr,
  void * untyped_ros_message)
{
  auto typed_message =
    static_cast<novatel_gps_msgs::msg::NovatelReceiverStatus *>(
    untyped_ros_message);
  return cdr_deserialize(cdr, *typed_message);
}

static uint32_t _NovatelReceiverStatus__get_serialized_size(
  const void * untyped_ros_message)
{
  auto typed_message =
    static_cast<const novatel_gps_msgs::msg::NovatelReceiverStatus *>(
    untyped_ros_message);
  return static_cast<uint32_t>(get_serialized_size(*typed_message, 0));
}

static size_t _NovatelReceiverStatus__max_serialized_size(char & bounds_info)
{
  bool full_bounded;
  bool is_plain;
  size_t ret_val;

  ret_val = max_serialized_size_NovatelReceiverStatus(full_bounded, is_plain, 0);

  bounds_info =
    is_plain ? ROSIDL_TYPESUPPORT_FASTRTPS_PLAIN_TYPE :
    full_bounded ? ROSIDL_TYPESUPPORT_FASTRTPS_BOUNDED_TYPE : ROSIDL_TYPESUPPORT_FASTRTPS_UNBOUNDED_TYPE;
  return ret_val;
}

static message_type_support_callbacks_t _NovatelReceiverStatus__callbacks = {
  "novatel_gps_msgs::msg",
  "NovatelReceiverStatus",
  _NovatelReceiverStatus__cdr_serialize,
  _NovatelReceiverStatus__cdr_deserialize,
  _NovatelReceiverStatus__get_serialized_size,
  _NovatelReceiverStatus__max_serialized_size
};

static rosidl_message_type_support_t _NovatelReceiverStatus__handle = {
  rosidl_typesupport_fastrtps_cpp::typesupport_identifier,
  &_NovatelReceiverStatus__callbacks,
  get_message_typesupport_handle_function,
};

}  // namespace typesupport_fastrtps_cpp

}  // namespace msg

}  // namespace novatel_gps_msgs

namespace rosidl_typesupport_fastrtps_cpp
{

template<>
ROSIDL_TYPESUPPORT_FASTRTPS_CPP_EXPORT_novatel_gps_msgs
const rosidl_message_type_support_t *
get_message_type_support_handle<novatel_gps_msgs::msg::NovatelReceiverStatus>()
{
  return &novatel_gps_msgs::msg::typesupport_fastrtps_cpp::_NovatelReceiverStatus__handle;
}

}  // namespace rosidl_typesupport_fastrtps_cpp

#ifdef __cplusplus
extern "C"
{
#endif

const rosidl_message_type_support_t *
ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(rosidl_typesupport_fastrtps_cpp, novatel_gps_msgs, msg, NovatelReceiverStatus)() {
  return &novatel_gps_msgs::msg::typesupport_fastrtps_cpp::_NovatelReceiverStatus__handle;
}

#ifdef __cplusplus
}
#endif
